#ifndef _YSTRING_H
#define _YSTRING_H

#include <string.h>

#ifndef NULL
#define NULL 0L
#endif

/*
 * standard but not supported in ancient UNIX. (substituted by libsubst.a)
 */
#ifndef __GNU_LIBRARY__
extern char *strdup();
extern char *strstr();
#endif

/*
 * non-standard
 */
extern char *strcasestr();
extern char *strrpbrk();
extern char *stralloc();
extern char *strtail();
extern char *strtailstr();
extern char *scanint();
extern char *linescanX();
#define lineScan(s,l)	linescanX(s,l,sizeof(l))

extern char *wordscanX();
#define wordScan(s,w)	wordscanX(s,w,sizeof(w))

extern char *awordscan();
extern char *wordscanY();
extern char *valuescanX();
#define wordScanY(s,w,p) wordscanY(s,w,sizeof(w),p)

#define fieldScan(f,n,v) scan_field1(f,n,sizeof(n),v,sizeof(v))
#define majorminorScan(s,j,n) scan_namebody(s,j,sizeof(j),"/",n,sizeof(n),NULL)

typedef int MemFile[16];

typedef struct {
	char	sv_id[16];
	char  **sv_ev;
	int	sv_ec;
	int	sv_ecmax;
	MemFile	sv_MemF;
} StrVec;

extern char *SPrintf();
extern char *SVaddEnvf();

typedef struct {
	int	ut_type;
	int	ut_size;
	int	ut_leng;
	char   *ut_addr;
} UTag;
#define Utos(u,s)	utosX(u,s,sizeof(s))

#endif /* _YSTRING_H */
